package com.luticate.utils;

import com.luticate.utils.dbo.LuDbo;

import java.io.Serializable;
import java.util.AbstractMap;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * Created by robin on 10/20/16.
 */

public class TestDbo extends LuDbo implements Serializable {
    protected byte _byte;
    protected char _char;
    protected short _short;
    protected int _int;
    protected long _long;
    protected float _float;
    protected double _double;
    protected boolean _boolean;

    protected Byte _byteObject;
    protected Character _charObject;
    protected Short _shortObject;
    protected Integer _intObject;
    protected Long _longObject;
    protected Float _floatObject;
    protected Double _doubleObject;
    protected Boolean _booleanObject;

    protected String _string;

    protected Test2Dbo _test2Dbo;
    protected Test2Dbo _test2Dbo2;

    protected List<Integer> _integers;
    protected int[] _ints;

    protected List<Test2Dbo> _test2Dbos;
    protected Test2Dbo[] _dbos;

    protected HashMap<String, Integer> _hashMap;
    protected AbstractMap<String, Test2Dbo> _hashMap2;

    protected String _aNullString;
    protected Class _object = TestDbo.class;

    protected transient String _transientField;

    public byte getByte() {
        return _byte;
    }

    public void setByte(byte aByte) {
        _byte = aByte;
    }

    public char getChar() {
        return _char;
    }

    public void setChar(char aChar) {
        _char = aChar;
    }

    public short getShort() {
        return _short;
    }

    public void setShort(short aShort) {
        _short = aShort;
    }

    public int getInt() {
        return _int;
    }

    public void setInt(int anInt) {
        _int = anInt;
    }

    public long getLong() {
        return _long;
    }

    public void setLong(long aLong) {
        _long = aLong;
    }

    public float getFloat() {
        return _float;
    }

    public void setFloat(float aFloat) {
        _float = aFloat;
    }

    public double getDouble() {
        return _double;
    }

    public void setDouble(double aDouble) {
        _double = aDouble;
    }

    public boolean isBoolean() {
        return _boolean;
    }

    public void setBoolean(boolean aBoolean) {
        _boolean = aBoolean;
    }

    public Byte getByteObject() {
        return _byteObject;
    }

    public void setByteObject(Byte byteObject) {
        _byteObject = byteObject;
    }

    public Character getCharObject() {
        return _charObject;
    }

    public void setCharObject(Character charObject) {
        _charObject = charObject;
    }

    public Short getShortObject() {
        return _shortObject;
    }

    public void setShortObject(Short shortObject) {
        _shortObject = shortObject;
    }

    public Integer getIntObject() {
        return _intObject;
    }

    public void setIntObject(Integer intObject) {
        _intObject = intObject;
    }

    public Long getLongObject() {
        return _longObject;
    }

    public void setLongObject(Long longObject) {
        _longObject = longObject;
    }

    public Float getFloatObject() {
        return _floatObject;
    }

    public void setFloatObject(Float floatObject) {
        _floatObject = floatObject;
    }

    public Double getDoubleObject() {
        return _doubleObject;
    }

    public void setDoubleObject(Double doubleObject) {
        _doubleObject = doubleObject;
    }

    public Boolean getBooleanObject() {
        return _booleanObject;
    }

    public void setBooleanObject(Boolean booleanObject) {
        _booleanObject = booleanObject;
    }

    public String getString() {
        return _string;
    }

    public void setString(String string) {
        _string = string;
    }

    public Test2Dbo getTest2Dbo() {
        return _test2Dbo;
    }

    public void setTest2Dbo(Test2Dbo test2Dbo) {
        _test2Dbo = test2Dbo;
    }

    public Test2Dbo getTest2Dbo2() {
        return _test2Dbo2;
    }

    public void setTest2Dbo2(Test2Dbo test2Dbo2) {
        _test2Dbo2 = test2Dbo2;
    }

    public List<Integer> getIntegers() {
        return _integers;
    }

    public void setIntegers(List<Integer> integers) {
        _integers = integers;
    }

    public int[] getInts() {
        return _ints;
    }

    public void setInts(int[] ints) {
        _ints = ints;
    }

    public List<Test2Dbo> getTest2Dbos() {
        return _test2Dbos;
    }

    public void setTest2Dbos(List<Test2Dbo> test2Dbos) {
        _test2Dbos = test2Dbos;
    }

    public Test2Dbo[] getDbos() {
        return _dbos;
    }

    public void setDbos(Test2Dbo[] dbos) {
        _dbos = dbos;
    }

    public HashMap<String, Integer> getHashMap() {
        return _hashMap;
    }

    public void setHashMap(HashMap<String, Integer> hashMap) {
        _hashMap = hashMap;
    }

    public AbstractMap<String, Test2Dbo> getHashMap2() {
        return _hashMap2;
    }

    public void setHashMap2(AbstractMap<String, Test2Dbo> hashMap2) {
        _hashMap2 = hashMap2;
    }

    public String getaNullString() {
        return _aNullString;
    }

    public void setaNullString(String aNullString) {
        _aNullString = aNullString;
    }

    public Class getObject() {
        return _object;
    }

    public void setObject(Class object) {
        _object = object;
    }

    public String getTransientField() {
        return _transientField;
    }

    public void setTransientField(String transientField) {
        _transientField = transientField;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        TestDbo testDbo = (TestDbo) o;

        if (_byte != testDbo._byte) return false;
        if (_char != testDbo._char) return false;
        if (_short != testDbo._short) return false;
        if (_int != testDbo._int) return false;
        if (_long != testDbo._long) return false;
        if (Float.compare(testDbo._float, _float) != 0) return false;
        if (Double.compare(testDbo._double, _double) != 0) return false;
        if (_boolean != testDbo._boolean) return false;
        if (_byteObject != null ? !_byteObject.equals(testDbo._byteObject) : testDbo._byteObject != null)
            return false;
        if (_charObject != null ? !_charObject.equals(testDbo._charObject) : testDbo._charObject != null)
            return false;
        if (_shortObject != null ? !_shortObject.equals(testDbo._shortObject) : testDbo._shortObject != null)
            return false;
        if (_intObject != null ? !_intObject.equals(testDbo._intObject) : testDbo._intObject != null)
            return false;
        if (_longObject != null ? !_longObject.equals(testDbo._longObject) : testDbo._longObject != null)
            return false;
        if (_floatObject != null ? !_floatObject.equals(testDbo._floatObject) : testDbo._floatObject != null)
            return false;
        if (_doubleObject != null ? !_doubleObject.equals(testDbo._doubleObject) : testDbo._doubleObject != null)
            return false;
        if (_booleanObject != null ? !_booleanObject.equals(testDbo._booleanObject) : testDbo._booleanObject != null)
            return false;
        if (_string != null ? !_string.equals(testDbo._string) : testDbo._string != null)
            return false;
        if (_test2Dbo != null ? !_test2Dbo.equals(testDbo._test2Dbo) : testDbo._test2Dbo != null)
            return false;
        if (_test2Dbo2 != null ? !_test2Dbo2.equals(testDbo._test2Dbo2) : testDbo._test2Dbo2 != null)
            return false;
        if (_integers != null ? !_integers.equals(testDbo._integers) : testDbo._integers != null)
            return false;
        if (!Arrays.equals(_ints, testDbo._ints)) return false;
        if (_test2Dbos != null ? !_test2Dbos.equals(testDbo._test2Dbos) : testDbo._test2Dbos != null)
            return false;
        // Probably incorrect - comparing Object[] arrays with Arrays.equals
        if (!Arrays.equals(_dbos, testDbo._dbos)) return false;
        if (_hashMap != null ? !_hashMap.equals(testDbo._hashMap) : testDbo._hashMap != null)
            return false;
        if (_hashMap2 != null ? !_hashMap2.equals(testDbo._hashMap2) : testDbo._hashMap2 != null)
            return false;
        if (_aNullString != null ? !_aNullString.equals(testDbo._aNullString) : testDbo._aNullString != null)
            return false;
        return _object != null ? _object.equals(testDbo._object) : testDbo._object == null;

    }

    @Override
    public int hashCode() {
        int result;
        long temp;
        result = (int) _byte;
        result = 31 * result + (int) _char;
        result = 31 * result + (int) _short;
        result = 31 * result + _int;
        result = 31 * result + (int) (_long ^ (_long >>> 32));
        result = 31 * result + (_float != +0.0f ? Float.floatToIntBits(_float) : 0);
        temp = Double.doubleToLongBits(_double);
        result = 31 * result + (int) (temp ^ (temp >>> 32));
        result = 31 * result + (_boolean ? 1 : 0);
        result = 31 * result + (_byteObject != null ? _byteObject.hashCode() : 0);
        result = 31 * result + (_charObject != null ? _charObject.hashCode() : 0);
        result = 31 * result + (_shortObject != null ? _shortObject.hashCode() : 0);
        result = 31 * result + (_intObject != null ? _intObject.hashCode() : 0);
        result = 31 * result + (_longObject != null ? _longObject.hashCode() : 0);
        result = 31 * result + (_floatObject != null ? _floatObject.hashCode() : 0);
        result = 31 * result + (_doubleObject != null ? _doubleObject.hashCode() : 0);
        result = 31 * result + (_booleanObject != null ? _booleanObject.hashCode() : 0);
        result = 31 * result + (_string != null ? _string.hashCode() : 0);
        result = 31 * result + (_test2Dbo != null ? _test2Dbo.hashCode() : 0);
        result = 31 * result + (_test2Dbo2 != null ? _test2Dbo2.hashCode() : 0);
        result = 31 * result + (_integers != null ? _integers.hashCode() : 0);
        result = 31 * result + Arrays.hashCode(_ints);
        result = 31 * result + (_test2Dbos != null ? _test2Dbos.hashCode() : 0);
        result = 31 * result + Arrays.hashCode(_dbos);
        result = 31 * result + (_hashMap != null ? _hashMap.hashCode() : 0);
        result = 31 * result + (_hashMap2 != null ? _hashMap2.hashCode() : 0);
        result = 31 * result + (_aNullString != null ? _aNullString.hashCode() : 0);
        result = 31 * result + (_object != null ? _object.hashCode() : 0);
        return result;
    }
}
