package com.luticate.utils.dataaccess;

import com.luticate.utils.business.LuPromise;
import com.luticate.utils.dbo.LuDataAccessConfigDbo;
import com.luticate.utils.dbo.LuDbo;

import java.util.HashMap;

/**
 * Created by robin on 11/27/15.
 */
public abstract class LuDataAccess {

    public static <T extends LuDbo> LuPromise<T> get(final LuDataAccessConfigDbo config, Class<T> type,
                                                     String url, final HashMap<String, String> getParams)
    {
        return LuRequest.get(config, type, url, getParams);
    }

    public static <T extends LuDbo> LuPromise<T> get(LuDataAccessConfigDbo config, Class<T> type,
                                                     String url)
    {
        return LuRequest.get(config, type, url);
    }

    public static <T extends LuDbo> LuPromise<T> post(LuDataAccessConfigDbo config, Class<T> type,
                                                      String url, final HashMap<String, String> postParams)
    {
        return LuRequest.post(config, type, url, postParams);
    }

    public static <T extends LuDbo> LuPromise<T> post(LuDataAccessConfigDbo config, Class<T> type,
                                                      String url)
    {
        return LuRequest.post(config, type, url);
    }
}
