package com.luticate.utils.dbo.JSONContainer;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

/**
 * Created by robin on 10/21/16.
 */

public interface LuAbstractJsonContainer {
    int getInt(Object key) throws JSONException;
    String getString(Object key) throws JSONException;
    long getLong(Object key) throws JSONException;
    double getDouble(Object key) throws JSONException;
    boolean getBoolean(Object key) throws JSONException;
    JSONObject getJSONObject(Object key) throws JSONException;
    JSONArray getJSONArray(Object key) throws JSONException;
    boolean isNull(Object key) throws JSONException;
}
